package se.nekotronic.readypinger;

import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.text.format.Time;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.content.Context;

public class ReadyPingActivity extends Activity implements OnClickListener {
	private TextView bigtextarea;
	private Button start_button;
	private Button middle_button;
	private Button quit_button;
    private PingThread ping_thread = null;
    // public static final String host = "192.168.0.10";
    public static final String host = "basen.oru.se";
    public static final int port = 2003;
    private AsyncTask onguitask = new AsyncTask() {
		@Override
		protected Object doInBackground(Object... params) {
			String line = (String) params[0];
			bigtextarea.setText(line + bigtextarea.getText());
	    	bigtextarea.invalidate();
			return null;
		}
    };
    
    private LocationManager location_manager;
    private LocationListener location_listener;
	
	private double latest_longitude;
	private double latest_latitude;
	
	public double getLatestLongitude() { return latest_longitude; }
	public double getLatestLatitude() { return latest_latitude; }
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ready_ping);
        bigtextarea = (TextView)findViewById(R.id.bigtextarea);
        start_button = (Button)findViewById(R.id.start_button);
        start_button.setOnClickListener(this);
        middle_button = (Button)findViewById(R.id.middle_button);
        middle_button.setOnClickListener(this);
        quit_button = (Button)findViewById(R.id.quit_button);
        quit_button.setOnClickListener(this);
        
        location_manager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
        location_listener = new LocationListener() {

				@Override
        		public void onLocationChanged(Location location) {
     		 	    latest_latitude = location.getLatitude();
        			latest_longitude = location.getLongitude();
				}
				
						@Override
						public void onProviderDisabled(String arg0) { }

						@Override
						public void onProviderEnabled(String arg0) { }

						@Override
						public void onStatusChanged(String arg0, int arg1, Bundle arg2) { }
        };
        
        bigtextarea.setText("");
        print("ReadyPing: Appen startar.");
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_ready_ping, menu);
        return true;
    }

    	
    	    @Override
    	    protected void onResume() {
    	        super.onResume();
    	        try {
    	            // Register the listener with the Location Manager to receive
    	            // location updates
    	            location_manager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, location_listener);
    	        }
    	        catch (Exception e) {
    	            warning("Couldn't use the GPS: " + e + ", " + e.getMessage());
   	        }
   	    }

    	       @Override
       	    protected void onPause() {
       	        super.onPause();
       	        location_manager.removeUpdates(location_listener);
       	    }

    	       public void OLDprint(String message) {
    	Time now = new Time();
    	now.setToNow();
    	String timeString = now.format("%H:%M:%S");
    	String line = timeString + ": " + message + "\n";
    	bigtextarea.setText(line + bigtextarea.getText());
    	// bigtextarea.invalidate();
    	bigtextarea.postInvalidate();
    }

    public void print(String message) {
    	Time now = new Time();
    	now.setToNow();
    	String timeString = now.format("%H:%M:%S");
    	final String line = timeString + ": " + message + "\n";
    	bigtextarea.post(new Runnable() {
			@Override
			public void run() {
				bigtextarea.setText(line + bigtextarea.getText());
		    	bigtextarea.invalidate();
			}
    	});
    } // print

    public void warning(String message) {
    	print("Warning! " + message);
    }
    
	@Override
	public void onClick(View view) {
		Log.d("*** ReadyPinger", "Button clicked: view = " + view.toString() + "\n");
		// bigtextarea.append("View  = " + view.toString());
		bigtextarea.invalidate();
		if (view == start_button) {
			Log.d("*** ReadyPinger", "Start Button Clicked");
			if (ping_thread != null) {
				warning("Already running.");
			}
			else {
				ping_thread = new PingThread(this, 100);
				ping_thread.start();
			}
		}
		else if (view == middle_button) {
			Log.d("*** ReadyPinger", "Middle Button Clicked");
			print("Please don't press that button again.");
		}
		else if (view == quit_button) {
			Log.d("*** ReadyPinger", "Quit Button Clicked");
			if (ping_thread != null)
				ping_thread.please_stop();
			this.finish();
		}
	}

	public void done() {
		ping_thread = null;

	}
}
